diff --git a/src/pngnq.c b/src/pngnq.c
index 2fa314d..7b415ef 100755
--- a/src/pngnq.c
+++ b/src/pngnq.c
@@ -706,10 +706,10 @@ static void remap_floyd(int cols, int rows, unsigned char map[MAXNETSIZE][4], un
         outrow = rwpng_info.interlaced? row_pointers[row] :
         rwpng_info.indexed_data;
     
-        int rederr=0;
-        int blueerr=0;
-        int greenerr=0;
-        int alphaerr=0;
+        double rederr=0;
+        double blueerr=0;
+        double greenerr=0;
+        double alphaerr=0;
         
         offset = row*cols*4;
         nextoffset = offset; if (row+1<rows) nextoffset += cols*4;        
@@ -725,7 +725,7 @@ static void remap_floyd(int cols, int rows, unsigned char map[MAXNETSIZE][4], un
         for( i=0;i<cols;i++, offset+=increment, nextoffset+=increment)
         {
             int idx;
-            unsigned int floyderr = rederr*rederr + greenerr*greenerr + blueerr*blueerr + alphaerr*alphaerr;
+            double floyderr = rederr*rederr + greenerr*greenerr + blueerr*blueerr + alphaerr*alphaerr;
             
             idx = inxsearch(CLAMP(rwpng_info.rgba_data[offset+3] - alphaerr),
                             CLAMP(rwpng_info.rgba_data[offset+2] - blueerr),
@@ -740,17 +740,17 @@ static void remap_floyd(int cols, int rows, unsigned char map[MAXNETSIZE][4], un
                 colorimp = 255 - ((255-alpha) * (255-alpha) / 255);
             } 
 
-            int thisrederr=(map[idx][0] -   rwpng_info.rgba_data[offset]) * colorimp   / 255; 
-            int thisblueerr=(map[idx][1] - rwpng_info.rgba_data[offset+1]) * colorimp  / 255; 
-            int thisgreenerr=(map[idx][2] -  rwpng_info.rgba_data[offset+2]) * colorimp  / 255;
-            int thisalphaerr=map[idx][3] - rwpng_info.rgba_data[offset+3];         
+            double thisrederr=(map[idx][0] -   rwpng_info.rgba_data[offset]) * colorimp   / 255; 
+            double thisblueerr=(map[idx][1] - rwpng_info.rgba_data[offset+1]) * colorimp  / 255; 
+            double thisgreenerr=(map[idx][2] -  rwpng_info.rgba_data[offset+2]) * colorimp  / 255;
+            double thisalphaerr=map[idx][3] - rwpng_info.rgba_data[offset+3];         
 
             rederr += thisrederr;
             greenerr += thisblueerr;
             blueerr +=  thisgreenerr;
             alphaerr += thisalphaerr;
             
-            unsigned int thiserr = (thisrederr*thisrederr + thisblueerr*thisblueerr + thisgreenerr*thisgreenerr + thisalphaerr*thisalphaerr)*2;
+            double thiserr = (thisrederr*thisrederr + thisblueerr*thisblueerr + thisgreenerr*thisgreenerr + thisalphaerr*thisalphaerr)*2;
              floyderr = rederr*rederr + greenerr*greenerr + blueerr*blueerr + alphaerr*alphaerr;
             
             int L = quantization_method;